# log4cplus::spi::ObjectRegistryBase Class Reference

This is the base class used to implement the functionality required by the ObjectRegistry template class. More...

`#include <objectregistry.h>`

Inheritance diagram for log4cplus::spi::ObjectRegistryBase:

[legend]
List of all members.

## Public Member Functions

bool | exists (const log4cplus::tstring &name) const
| Tests to see whether or not an object is bound in the registry as `name`.
std::vector< log4cplus::tstring > | getAllNames () const
| Returns the names of all registered objects.

## Protected Types

typedef std::map< log4cplus::tstring, void * > | ObjectMap

## Protected Member Functions

| ObjectRegistryBase ()
virtual | ~ObjectRegistryBase ()
bool | putVal (const log4cplus::tstring &name, void *object)
| Used to enter an object into the registry.
void * | getVal (const log4cplus::tstring &name) const
| Used to retrieve an object from the registry.
virtual void | deleteObject (void *object) const=0
| Deletes `object`.
virtual void | clear ()
| Deletes all objects from this registry.

## Protected Attributes

LOG4CPLUS_MUTEX_PTR_DECLARE | mutex
ObjectMap | data

## Detailed Description

This is the base class used to implement the functionality required by the ObjectRegistry template class.

Definition at line 34 of file objectregistry.h.

## Member Typedef Documentation

typedef std::map<log4cplus::tstring, void*> log4cplus::spi::ObjectRegistryBase::ObjectMap`[protected]`

| Definition at line 77 of file objectregistry.h.

## Constructor & Destructor Documentation

log4cplus::spi::ObjectRegistryBase::ObjectRegistryBase | ( |  | ) | `[protected]`

virtual log4cplus::spi::ObjectRegistryBase::~ObjectRegistryBase | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

virtual void log4cplus::spi::ObjectRegistryBase::clear | ( |  | ) | `[protected, virtual]`

| Deletes all objects from this registry.

virtual void log4cplus::spi::ObjectRegistryBase::deleteObject | ( | void * | object | ) | const`[protected, pure virtual]`

| Deletes `object`. Implemented in log4cplus::spi::FactoryRegistry< T >.

bool log4cplus::spi::ObjectRegistryBase::exists | ( | const log4cplus::tstring & | name | ) | const

| Tests to see whether or not an object is bound in the registry as `name`.

std::vector<log4cplus::tstring> log4cplus::spi::ObjectRegistryBase::getAllNames | ( |  | ) | const

| Returns the names of all registered objects.

void* log4cplus::spi::ObjectRegistryBase::getVal | ( | const log4cplus::tstring & | name | ) | const`[protected]`

| Used to retrieve an object from the registry. (The registry owns the returned pointer.)

bool log4cplus::spi::ObjectRegistryBase::putVal | ( | const log4cplus::tstring & | name,
|  | void * | object
| ) | `[protected]`

| Used to enter an object into the registry. (The registry now owns `object`.)

## Member Data Documentation

ObjectMap log4cplus::spi::ObjectRegistryBase::data`[protected]`

| Definition at line 81 of file objectregistry.h.

LOG4CPLUS_MUTEX_PTR_DECLARE log4cplus::spi::ObjectRegistryBase::mutex`[protected]`

| Definition at line 80 of file objectregistry.h.

The documentation for this class was generated from the following file:

- objectregistry.h